Index: configs/cdr_mysql.conf.sample
===================================================================
--- configs/cdr_mysql.conf.sample	(revision 679)
+++ configs/cdr_mysql.conf.sample	(working copy)
@@ -19,6 +19,11 @@
 ;port=3306
 ;sock=/tmp/mysql.sock
 ;
+; If your system's locale differs from mysql database character set,
+; cdr_mysql can damage non-latin characters in CDR variables. Use this
+; option to protect your data.
+;charset=koi8r
+;
 ; Older versions of cdr_mysql set the calldate field to whenever the
 ; record was posted, rather than the start date of the call.  This flag
 ; reverts to the old (incorrect) behavior.  Note that you'll also need
Index: cdr/cdr_addon_mysql.c
===================================================================
--- cdr/cdr_addon_mysql.c	(revision 679)
+++ cdr/cdr_addon_mysql.c	(working copy)
@@ -59,7 +59,7 @@
 static char *name = "mysql";
 static char *config = "cdr_mysql.conf";
 
-static struct ast_str *hostname = NULL, *dbname = NULL, *dbuser = NULL, *password = NULL, *dbsock = NULL, *dbtable = NULL;
+static struct ast_str *hostname = NULL, *dbname = NULL, *dbuser = NULL, *password = NULL, *dbsock = NULL, *dbtable = NULL, *dbcharset = NULL;
 
 static struct ast_str *ssl_ca = NULL, *ssl_cert = NULL, *ssl_key = NULL;
 
@@ -185,6 +185,11 @@
 			connected = 1;
 			connect_time = time(NULL);
 			records = 0;
+			if (dbcharset) {
+				sprintf(sql1, "set names '%s'", dbcharset->str);
+				mysql_real_query(&mysql, sql1, strlen(sql1));
+				ast_debug(1, "SQL command as follows: %s\n", sql1);
+			}
 		} else {
 			ast_log(LOG_ERROR, "Cannot connect to database server %s: (%d) %s\n", hostname->str, mysql_errno(&mysql), mysql_error(&mysql));
 			connected = 0;
@@ -443,6 +448,8 @@
 	res |= my_load_config_string(cfg, "global", "table", &dbtable, "cdr");
 	res |= my_load_config_string(cfg, "global", "password", &password, "");
 
+	res |= my_load_config_string(cfg, "global", "charset", &dbcharset, "");
+
 	res |= my_load_config_string(cfg, "global", "ssl_ca", &ssl_ca, "");
 	res |= my_load_config_string(cfg, "global", "ssl_cert", &ssl_cert, "");
 	res |= my_load_config_string(cfg, "global", "ssl_key", &ssl_key, "");
@@ -475,6 +482,10 @@
 	ast_debug(1, "Got password of %s\n", password->str);
 	ast_debug(1, "%sunning in calldate compatibility mode\n", calldate_compat ? "R" : "Not r");
 
+	if (dbcharset) {
+		ast_debug(1, "Got DB charste of %s\n", dbcharset->str);
+	}
+
 	mysql_init(&mysql);
 
 	if (timeout && mysql_options(&mysql, MYSQL_OPT_CONNECT_TIMEOUT, (char *)&timeout) != 0) {
@@ -501,6 +512,11 @@
 		connected = 1;
 		records = 0;
 		connect_time = time(NULL);
+		if (dbcharset) {
+			sprintf(sqldesc, "set names '%s'", dbcharset->str);
+			mysql_real_query(&mysql, sqldesc, strlen(sqldesc));
+			ast_debug(1, "SQL command as follows: %s\n", sqldesc);
+		}
 
 		/* Get table description */
 		snprintf(sqldesc, sizeof(sqldesc), "DESC %s", dbtable ? dbtable->str : "cdr");
